// $ANTLR 3.1 MeterSimulator.g 2013-11-21 16:54:42

package com.persagy.simulator;


import org.antlr.runtime.*;


import org.antlr.runtime.tree.*;

public class MeterSimulatorParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "NEWLINE", "DOUBLE", "INTEGER", "CONSTANT", "ID", "F0", "F1", "F1DATE", "F2", "WS", "'+'", "'-'", "'*'", "'/'", "'%'", "'('", "')'", "'if'", "'{'", "'}'", "'elseif'", "'else'", "'||'", "'&&'", "'!'", "'['", "'<'", "'<='", "'>'", "'>='", "'=='", "'!='", "']'", "','"
    };
    public static final int INTEGER=6;
    public static final int T__29=29;
    public static final int T__28=28;
    public static final int T__27=27;
    public static final int T__26=26;
    public static final int T__25=25;
    public static final int T__24=24;
    public static final int T__23=23;
    public static final int T__22=22;
    public static final int T__21=21;
    public static final int T__20=20;
    public static final int ID=8;
    public static final int EOF=-1;
    public static final int T__30=30;
    public static final int T__19=19;
    public static final int T__31=31;
    public static final int T__32=32;
    public static final int WS=13;
    public static final int T__33=33;
    public static final int T__16=16;
    public static final int T__34=34;
    public static final int T__15=15;
    public static final int NEWLINE=4;
    public static final int T__35=35;
    public static final int T__18=18;
    public static final int T__36=36;
    public static final int T__17=17;
    public static final int T__37=37;
    public static final int T__14=14;
    public static final int F1=10;
    public static final int F0=9;
    public static final int CONSTANT=7;
    public static final int DOUBLE=5;
    public static final int F2=12;
    public static final int F1DATE=11;

    // delegates
    // delegators


        public MeterSimulatorParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public MeterSimulatorParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return MeterSimulatorParser.tokenNames; }
    public String getGrammarFileName() { return "MeterSimulator.g"; }


    	public Object recoverFromMismatchedToken(IntStream input, int ttype, BitSet follow) throws RecognitionException
    	{
    		throw new MismatchedTokenException(ttype, input);
    	}

    	public Object recoverFromMismatchedSet(IntStream input,RecognitionException e,BitSet follow) throws RecognitionException
    	{
    		throw e;
    	}


    public static class prog_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "prog"
    // MeterSimulator.g:52:1: prog : expr NEWLINE ;
    public final MeterSimulatorParser.prog_return prog() throws RecognitionException {
        MeterSimulatorParser.prog_return retval = new MeterSimulatorParser.prog_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token NEWLINE2=null;
        MeterSimulatorParser.expr_return expr1 = null;


        CommonTree NEWLINE2_tree=null;

        try {
            // MeterSimulator.g:53:2: ( expr NEWLINE )
            // MeterSimulator.g:53:4: expr NEWLINE
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_expr_in_prog82);
            expr1=expr();

            state._fsp--;

            adaptor.addChild(root_0, expr1.getTree());
            NEWLINE2=(Token)match(input,NEWLINE,FOLLOW_NEWLINE_in_prog84); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        	catch (RecognitionException e) {
        	    throw e;
        	}
        finally {
        }
        return retval;
    }
    // $ANTLR end "prog"

    public static class expr_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "expr"
    // MeterSimulator.g:56:1: expr : ( fourexpr | ifcondition );
    public final MeterSimulatorParser.expr_return expr() throws RecognitionException {
        MeterSimulatorParser.expr_return retval = new MeterSimulatorParser.expr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        MeterSimulatorParser.fourexpr_return fourexpr3 = null;

        MeterSimulatorParser.ifcondition_return ifcondition4 = null;



        try {
            // MeterSimulator.g:57:2: ( fourexpr | ifcondition )
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( ((LA1_0>=DOUBLE && LA1_0<=F2)||LA1_0==19) ) {
                alt1=1;
            }
            else if ( (LA1_0==21) ) {
                alt1=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 1, 0, input);

                throw nvae;
            }
            switch (alt1) {
                case 1 :
                    // MeterSimulator.g:57:4: fourexpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_fourexpr_in_expr97);
                    fourexpr3=fourexpr();

                    state._fsp--;

                    adaptor.addChild(root_0, fourexpr3.getTree());

                    }
                    break;
                case 2 :
                    // MeterSimulator.g:58:4: ifcondition
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_ifcondition_in_expr102);
                    ifcondition4=ifcondition();

                    state._fsp--;

                    adaptor.addChild(root_0, ifcondition4.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        	catch (RecognitionException e) {
        	    throw e;
        	}
        finally {
        }
        return retval;
    }
    // $ANTLR end "expr"

    public static class fourexpr_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "fourexpr"
    // MeterSimulator.g:61:1: fourexpr : multexpr ( ( '+' | '-' ) multexpr )* ;
    public final MeterSimulatorParser.fourexpr_return fourexpr() throws RecognitionException {
        MeterSimulatorParser.fourexpr_return retval = new MeterSimulatorParser.fourexpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token char_literal6=null;
        Token char_literal7=null;
        MeterSimulatorParser.multexpr_return multexpr5 = null;

        MeterSimulatorParser.multexpr_return multexpr8 = null;


        CommonTree char_literal6_tree=null;
        CommonTree char_literal7_tree=null;

        try {
            // MeterSimulator.g:62:2: ( multexpr ( ( '+' | '-' ) multexpr )* )
            // MeterSimulator.g:62:4: multexpr ( ( '+' | '-' ) multexpr )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_multexpr_in_fourexpr113);
            multexpr5=multexpr();

            state._fsp--;

            adaptor.addChild(root_0, multexpr5.getTree());
            // MeterSimulator.g:62:13: ( ( '+' | '-' ) multexpr )*
            loop3:
            do {
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( ((LA3_0>=14 && LA3_0<=15)) ) {
                    alt3=1;
                }


                switch (alt3) {
            	case 1 :
            	    // MeterSimulator.g:62:14: ( '+' | '-' ) multexpr
            	    {
            	    // MeterSimulator.g:62:14: ( '+' | '-' )
            	    int alt2=2;
            	    int LA2_0 = input.LA(1);

            	    if ( (LA2_0==14) ) {
            	        alt2=1;
            	    }
            	    else if ( (LA2_0==15) ) {
            	        alt2=2;
            	    }
            	    else {
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 2, 0, input);

            	        throw nvae;
            	    }
            	    switch (alt2) {
            	        case 1 :
            	            // MeterSimulator.g:62:15: '+'
            	            {
            	            char_literal6=(Token)match(input,14,FOLLOW_14_in_fourexpr117); 
            	            char_literal6_tree = (CommonTree)adaptor.create(char_literal6);
            	            root_0 = (CommonTree)adaptor.becomeRoot(char_literal6_tree, root_0);


            	            }
            	            break;
            	        case 2 :
            	            // MeterSimulator.g:62:20: '-'
            	            {
            	            char_literal7=(Token)match(input,15,FOLLOW_15_in_fourexpr120); 
            	            char_literal7_tree = (CommonTree)adaptor.create(char_literal7);
            	            root_0 = (CommonTree)adaptor.becomeRoot(char_literal7_tree, root_0);


            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_multexpr_in_fourexpr124);
            	    multexpr8=multexpr();

            	    state._fsp--;

            	    adaptor.addChild(root_0, multexpr8.getTree());

            	    }
            	    break;

            	default :
            	    break loop3;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        	catch (RecognitionException e) {
        	    throw e;
        	}
        finally {
        }
        return retval;
    }
    // $ANTLR end "fourexpr"

    public static class multexpr_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "multexpr"
    // MeterSimulator.g:65:1: multexpr : atom ( ( '*' | '/' | '%' ) atom )* ;
    public final MeterSimulatorParser.multexpr_return multexpr() throws RecognitionException {
        MeterSimulatorParser.multexpr_return retval = new MeterSimulatorParser.multexpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token char_literal10=null;
        Token char_literal11=null;
        Token char_literal12=null;
        MeterSimulatorParser.atom_return atom9 = null;

        MeterSimulatorParser.atom_return atom13 = null;


        CommonTree char_literal10_tree=null;
        CommonTree char_literal11_tree=null;
        CommonTree char_literal12_tree=null;

        try {
            // MeterSimulator.g:66:2: ( atom ( ( '*' | '/' | '%' ) atom )* )
            // MeterSimulator.g:66:4: atom ( ( '*' | '/' | '%' ) atom )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_atom_in_multexpr138);
            atom9=atom();

            state._fsp--;

            adaptor.addChild(root_0, atom9.getTree());
            // MeterSimulator.g:66:9: ( ( '*' | '/' | '%' ) atom )*
            loop5:
            do {
                int alt5=2;
                int LA5_0 = input.LA(1);

                if ( ((LA5_0>=16 && LA5_0<=18)) ) {
                    alt5=1;
                }


                switch (alt5) {
            	case 1 :
            	    // MeterSimulator.g:66:10: ( '*' | '/' | '%' ) atom
            	    {
            	    // MeterSimulator.g:66:10: ( '*' | '/' | '%' )
            	    int alt4=3;
            	    switch ( input.LA(1) ) {
            	    case 16:
            	        {
            	        alt4=1;
            	        }
            	        break;
            	    case 17:
            	        {
            	        alt4=2;
            	        }
            	        break;
            	    case 18:
            	        {
            	        alt4=3;
            	        }
            	        break;
            	    default:
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 4, 0, input);

            	        throw nvae;
            	    }

            	    switch (alt4) {
            	        case 1 :
            	            // MeterSimulator.g:66:11: '*'
            	            {
            	            char_literal10=(Token)match(input,16,FOLLOW_16_in_multexpr142); 
            	            char_literal10_tree = (CommonTree)adaptor.create(char_literal10);
            	            root_0 = (CommonTree)adaptor.becomeRoot(char_literal10_tree, root_0);


            	            }
            	            break;
            	        case 2 :
            	            // MeterSimulator.g:66:16: '/'
            	            {
            	            char_literal11=(Token)match(input,17,FOLLOW_17_in_multexpr145); 
            	            char_literal11_tree = (CommonTree)adaptor.create(char_literal11);
            	            root_0 = (CommonTree)adaptor.becomeRoot(char_literal11_tree, root_0);


            	            }
            	            break;
            	        case 3 :
            	            // MeterSimulator.g:66:21: '%'
            	            {
            	            char_literal12=(Token)match(input,18,FOLLOW_18_in_multexpr148); 
            	            char_literal12_tree = (CommonTree)adaptor.create(char_literal12);
            	            root_0 = (CommonTree)adaptor.becomeRoot(char_literal12_tree, root_0);


            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_atom_in_multexpr152);
            	    atom13=atom();

            	    state._fsp--;

            	    adaptor.addChild(root_0, atom13.getTree());

            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        	catch (RecognitionException e) {
        	    throw e;
        	}
        finally {
        }
        return retval;
    }
    // $ANTLR end "multexpr"

    public static class atom_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "atom"
    // MeterSimulator.g:69:1: atom : ( DOUBLE | INTEGER | CONSTANT | ID | func | '(' fourexpr ')' );
    public final MeterSimulatorParser.atom_return atom() throws RecognitionException {
        MeterSimulatorParser.atom_return retval = new MeterSimulatorParser.atom_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token DOUBLE14=null;
        Token INTEGER15=null;
        Token CONSTANT16=null;
        Token ID17=null;
        Token char_literal19=null;
        Token char_literal21=null;
        MeterSimulatorParser.func_return func18 = null;

        MeterSimulatorParser.fourexpr_return fourexpr20 = null;


        CommonTree DOUBLE14_tree=null;
        CommonTree INTEGER15_tree=null;
        CommonTree CONSTANT16_tree=null;
        CommonTree ID17_tree=null;
        CommonTree char_literal19_tree=null;
        CommonTree char_literal21_tree=null;

        try {
            // MeterSimulator.g:70:2: ( DOUBLE | INTEGER | CONSTANT | ID | func | '(' fourexpr ')' )
            int alt6=6;
            switch ( input.LA(1) ) {
            case DOUBLE:
                {
                alt6=1;
                }
                break;
            case INTEGER:
                {
                alt6=2;
                }
                break;
            case CONSTANT:
                {
                alt6=3;
                }
                break;
            case ID:
                {
                alt6=4;
                }
                break;
            case F0:
            case F1:
            case F1DATE:
            case F2:
                {
                alt6=5;
                }
                break;
            case 19:
                {
                alt6=6;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 6, 0, input);

                throw nvae;
            }

            switch (alt6) {
                case 1 :
                    // MeterSimulator.g:70:4: DOUBLE
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    DOUBLE14=(Token)match(input,DOUBLE,FOLLOW_DOUBLE_in_atom166); 
                    DOUBLE14_tree = (CommonTree)adaptor.create(DOUBLE14);
                    adaptor.addChild(root_0, DOUBLE14_tree);


                    }
                    break;
                case 2 :
                    // MeterSimulator.g:71:4: INTEGER
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    INTEGER15=(Token)match(input,INTEGER,FOLLOW_INTEGER_in_atom171); 
                    INTEGER15_tree = (CommonTree)adaptor.create(INTEGER15);
                    adaptor.addChild(root_0, INTEGER15_tree);


                    }
                    break;
                case 3 :
                    // MeterSimulator.g:72:4: CONSTANT
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    CONSTANT16=(Token)match(input,CONSTANT,FOLLOW_CONSTANT_in_atom176); 
                    CONSTANT16_tree = (CommonTree)adaptor.create(CONSTANT16);
                    adaptor.addChild(root_0, CONSTANT16_tree);


                    }
                    break;
                case 4 :
                    // MeterSimulator.g:73:4: ID
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    ID17=(Token)match(input,ID,FOLLOW_ID_in_atom181); 
                    ID17_tree = (CommonTree)adaptor.create(ID17);
                    adaptor.addChild(root_0, ID17_tree);


                    }
                    break;
                case 5 :
                    // MeterSimulator.g:74:4: func
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_func_in_atom186);
                    func18=func();

                    state._fsp--;

                    adaptor.addChild(root_0, func18.getTree());

                    }
                    break;
                case 6 :
                    // MeterSimulator.g:75:5: '(' fourexpr ')'
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    char_literal19=(Token)match(input,19,FOLLOW_19_in_atom192); 
                    pushFollow(FOLLOW_fourexpr_in_atom195);
                    fourexpr20=fourexpr();

                    state._fsp--;

                    adaptor.addChild(root_0, fourexpr20.getTree());
                    char_literal21=(Token)match(input,20,FOLLOW_20_in_atom197); 

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        	catch (RecognitionException e) {
        	    throw e;
        	}
        finally {
        }
        return retval;
    }
    // $ANTLR end "atom"

    public static class ifcondition_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "ifcondition"
    // MeterSimulator.g:78:1: ifcondition : 'if' '(' condition ')' '{' expr '}' ( elseifcondition | elsecondition ) ;
    public final MeterSimulatorParser.ifcondition_return ifcondition() throws RecognitionException {
        MeterSimulatorParser.ifcondition_return retval = new MeterSimulatorParser.ifcondition_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token string_literal22=null;
        Token char_literal23=null;
        Token char_literal25=null;
        Token char_literal26=null;
        Token char_literal28=null;
        MeterSimulatorParser.condition_return condition24 = null;

        MeterSimulatorParser.expr_return expr27 = null;

        MeterSimulatorParser.elseifcondition_return elseifcondition29 = null;

        MeterSimulatorParser.elsecondition_return elsecondition30 = null;


        CommonTree string_literal22_tree=null;
        CommonTree char_literal23_tree=null;
        CommonTree char_literal25_tree=null;
        CommonTree char_literal26_tree=null;
        CommonTree char_literal28_tree=null;

        try {
            // MeterSimulator.g:79:2: ( 'if' '(' condition ')' '{' expr '}' ( elseifcondition | elsecondition ) )
            // MeterSimulator.g:79:4: 'if' '(' condition ')' '{' expr '}' ( elseifcondition | elsecondition )
            {
            root_0 = (CommonTree)adaptor.nil();

            string_literal22=(Token)match(input,21,FOLLOW_21_in_ifcondition210); 
            string_literal22_tree = (CommonTree)adaptor.create(string_literal22);
            root_0 = (CommonTree)adaptor.becomeRoot(string_literal22_tree, root_0);

            char_literal23=(Token)match(input,19,FOLLOW_19_in_ifcondition213); 
            pushFollow(FOLLOW_condition_in_ifcondition216);
            condition24=condition();

            state._fsp--;

            adaptor.addChild(root_0, condition24.getTree());
            char_literal25=(Token)match(input,20,FOLLOW_20_in_ifcondition218); 
            char_literal26=(Token)match(input,22,FOLLOW_22_in_ifcondition221); 
            pushFollow(FOLLOW_expr_in_ifcondition224);
            expr27=expr();

            state._fsp--;

            adaptor.addChild(root_0, expr27.getTree());
            char_literal28=(Token)match(input,23,FOLLOW_23_in_ifcondition226); 
            // MeterSimulator.g:79:45: ( elseifcondition | elsecondition )
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==24) ) {
                alt7=1;
            }
            else if ( (LA7_0==25) ) {
                alt7=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 7, 0, input);

                throw nvae;
            }
            switch (alt7) {
                case 1 :
                    // MeterSimulator.g:79:46: elseifcondition
                    {
                    pushFollow(FOLLOW_elseifcondition_in_ifcondition230);
                    elseifcondition29=elseifcondition();

                    state._fsp--;

                    adaptor.addChild(root_0, elseifcondition29.getTree());

                    }
                    break;
                case 2 :
                    // MeterSimulator.g:79:62: elsecondition
                    {
                    pushFollow(FOLLOW_elsecondition_in_ifcondition232);
                    elsecondition30=elsecondition();

                    state._fsp--;

                    adaptor.addChild(root_0, elsecondition30.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        	catch (RecognitionException e) {
        	    throw e;
        	}
        finally {
        }
        return retval;
    }
    // $ANTLR end "ifcondition"

    public static class elseifcondition_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "elseifcondition"
    // MeterSimulator.g:82:1: elseifcondition : 'elseif' '(' condition ')' '{' expr '}' ( elseifcondition | elsecondition ) ;
    public final MeterSimulatorParser.elseifcondition_return elseifcondition() throws RecognitionException {
        MeterSimulatorParser.elseifcondition_return retval = new MeterSimulatorParser.elseifcondition_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token string_literal31=null;
        Token char_literal32=null;
        Token char_literal34=null;
        Token char_literal35=null;
        Token char_literal37=null;
        MeterSimulatorParser.condition_return condition33 = null;

        MeterSimulatorParser.expr_return expr36 = null;

        MeterSimulatorParser.elseifcondition_return elseifcondition38 = null;

        MeterSimulatorParser.elsecondition_return elsecondition39 = null;


        CommonTree string_literal31_tree=null;
        CommonTree char_literal32_tree=null;
        CommonTree char_literal34_tree=null;
        CommonTree char_literal35_tree=null;
        CommonTree char_literal37_tree=null;

        try {
            // MeterSimulator.g:83:2: ( 'elseif' '(' condition ')' '{' expr '}' ( elseifcondition | elsecondition ) )
            // MeterSimulator.g:83:4: 'elseif' '(' condition ')' '{' expr '}' ( elseifcondition | elsecondition )
            {
            root_0 = (CommonTree)adaptor.nil();

            string_literal31=(Token)match(input,24,FOLLOW_24_in_elseifcondition244); 
            string_literal31_tree = (CommonTree)adaptor.create(string_literal31);
            root_0 = (CommonTree)adaptor.becomeRoot(string_literal31_tree, root_0);

            char_literal32=(Token)match(input,19,FOLLOW_19_in_elseifcondition247); 
            pushFollow(FOLLOW_condition_in_elseifcondition250);
            condition33=condition();

            state._fsp--;

            adaptor.addChild(root_0, condition33.getTree());
            char_literal34=(Token)match(input,20,FOLLOW_20_in_elseifcondition252); 
            char_literal35=(Token)match(input,22,FOLLOW_22_in_elseifcondition255); 
            pushFollow(FOLLOW_expr_in_elseifcondition258);
            expr36=expr();

            state._fsp--;

            adaptor.addChild(root_0, expr36.getTree());
            char_literal37=(Token)match(input,23,FOLLOW_23_in_elseifcondition260); 
            // MeterSimulator.g:83:49: ( elseifcondition | elsecondition )
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==24) ) {
                alt8=1;
            }
            else if ( (LA8_0==25) ) {
                alt8=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 8, 0, input);

                throw nvae;
            }
            switch (alt8) {
                case 1 :
                    // MeterSimulator.g:83:50: elseifcondition
                    {
                    pushFollow(FOLLOW_elseifcondition_in_elseifcondition264);
                    elseifcondition38=elseifcondition();

                    state._fsp--;

                    adaptor.addChild(root_0, elseifcondition38.getTree());

                    }
                    break;
                case 2 :
                    // MeterSimulator.g:83:66: elsecondition
                    {
                    pushFollow(FOLLOW_elsecondition_in_elseifcondition266);
                    elsecondition39=elsecondition();

                    state._fsp--;

                    adaptor.addChild(root_0, elsecondition39.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        	catch (RecognitionException e) {
        	    throw e;
        	}
        finally {
        }
        return retval;
    }
    // $ANTLR end "elseifcondition"

    public static class elsecondition_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "elsecondition"
    // MeterSimulator.g:86:1: elsecondition : 'else' '{' expr '}' ;
    public final MeterSimulatorParser.elsecondition_return elsecondition() throws RecognitionException {
        MeterSimulatorParser.elsecondition_return retval = new MeterSimulatorParser.elsecondition_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token string_literal40=null;
        Token char_literal41=null;
        Token char_literal43=null;
        MeterSimulatorParser.expr_return expr42 = null;


        CommonTree string_literal40_tree=null;
        CommonTree char_literal41_tree=null;
        CommonTree char_literal43_tree=null;

        try {
            // MeterSimulator.g:87:2: ( 'else' '{' expr '}' )
            // MeterSimulator.g:87:4: 'else' '{' expr '}'
            {
            root_0 = (CommonTree)adaptor.nil();

            string_literal40=(Token)match(input,25,FOLLOW_25_in_elsecondition279); 
            string_literal40_tree = (CommonTree)adaptor.create(string_literal40);
            root_0 = (CommonTree)adaptor.becomeRoot(string_literal40_tree, root_0);

            char_literal41=(Token)match(input,22,FOLLOW_22_in_elsecondition282); 
            pushFollow(FOLLOW_expr_in_elsecondition285);
            expr42=expr();

            state._fsp--;

            adaptor.addChild(root_0, expr42.getTree());
            char_literal43=(Token)match(input,23,FOLLOW_23_in_elsecondition287); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        	catch (RecognitionException e) {
        	    throw e;
        	}
        finally {
        }
        return retval;
    }
    // $ANTLR end "elsecondition"

    public static class condition_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "condition"
    // MeterSimulator.g:90:1: condition : andcondition ( ( '||' ) andcondition )* ;
    public final MeterSimulatorParser.condition_return condition() throws RecognitionException {
        MeterSimulatorParser.condition_return retval = new MeterSimulatorParser.condition_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token string_literal45=null;
        MeterSimulatorParser.andcondition_return andcondition44 = null;

        MeterSimulatorParser.andcondition_return andcondition46 = null;


        CommonTree string_literal45_tree=null;

        try {
            // MeterSimulator.g:91:2: ( andcondition ( ( '||' ) andcondition )* )
            // MeterSimulator.g:91:4: andcondition ( ( '||' ) andcondition )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_andcondition_in_condition300);
            andcondition44=andcondition();

            state._fsp--;

            adaptor.addChild(root_0, andcondition44.getTree());
            // MeterSimulator.g:91:17: ( ( '||' ) andcondition )*
            loop9:
            do {
                int alt9=2;
                int LA9_0 = input.LA(1);

                if ( (LA9_0==26) ) {
                    alt9=1;
                }


                switch (alt9) {
            	case 1 :
            	    // MeterSimulator.g:91:18: ( '||' ) andcondition
            	    {
            	    // MeterSimulator.g:91:18: ( '||' )
            	    // MeterSimulator.g:91:19: '||'
            	    {
            	    string_literal45=(Token)match(input,26,FOLLOW_26_in_condition304); 
            	    string_literal45_tree = (CommonTree)adaptor.create(string_literal45);
            	    root_0 = (CommonTree)adaptor.becomeRoot(string_literal45_tree, root_0);


            	    }

            	    pushFollow(FOLLOW_andcondition_in_condition308);
            	    andcondition46=andcondition();

            	    state._fsp--;

            	    adaptor.addChild(root_0, andcondition46.getTree());

            	    }
            	    break;

            	default :
            	    break loop9;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        	catch (RecognitionException e) {
        	    throw e;
        	}
        finally {
        }
        return retval;
    }
    // $ANTLR end "condition"

    public static class andcondition_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "andcondition"
    // MeterSimulator.g:94:1: andcondition : notcondition ( ( '&&' ) notcondition )* ;
    public final MeterSimulatorParser.andcondition_return andcondition() throws RecognitionException {
        MeterSimulatorParser.andcondition_return retval = new MeterSimulatorParser.andcondition_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token string_literal48=null;
        MeterSimulatorParser.notcondition_return notcondition47 = null;

        MeterSimulatorParser.notcondition_return notcondition49 = null;


        CommonTree string_literal48_tree=null;

        try {
            // MeterSimulator.g:95:2: ( notcondition ( ( '&&' ) notcondition )* )
            // MeterSimulator.g:95:4: notcondition ( ( '&&' ) notcondition )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_notcondition_in_andcondition322);
            notcondition47=notcondition();

            state._fsp--;

            adaptor.addChild(root_0, notcondition47.getTree());
            // MeterSimulator.g:95:17: ( ( '&&' ) notcondition )*
            loop10:
            do {
                int alt10=2;
                int LA10_0 = input.LA(1);

                if ( (LA10_0==27) ) {
                    alt10=1;
                }


                switch (alt10) {
            	case 1 :
            	    // MeterSimulator.g:95:18: ( '&&' ) notcondition
            	    {
            	    // MeterSimulator.g:95:18: ( '&&' )
            	    // MeterSimulator.g:95:19: '&&'
            	    {
            	    string_literal48=(Token)match(input,27,FOLLOW_27_in_andcondition326); 
            	    string_literal48_tree = (CommonTree)adaptor.create(string_literal48);
            	    root_0 = (CommonTree)adaptor.becomeRoot(string_literal48_tree, root_0);


            	    }

            	    pushFollow(FOLLOW_notcondition_in_andcondition330);
            	    notcondition49=notcondition();

            	    state._fsp--;

            	    adaptor.addChild(root_0, notcondition49.getTree());

            	    }
            	    break;

            	default :
            	    break loop10;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        	catch (RecognitionException e) {
        	    throw e;
        	}
        finally {
        }
        return retval;
    }
    // $ANTLR end "andcondition"

    public static class notcondition_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "notcondition"
    // MeterSimulator.g:98:1: notcondition : ( ( '!' ) itemcondition | itemcondition );
    public final MeterSimulatorParser.notcondition_return notcondition() throws RecognitionException {
        MeterSimulatorParser.notcondition_return retval = new MeterSimulatorParser.notcondition_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token char_literal50=null;
        MeterSimulatorParser.itemcondition_return itemcondition51 = null;

        MeterSimulatorParser.itemcondition_return itemcondition52 = null;


        CommonTree char_literal50_tree=null;

        try {
            // MeterSimulator.g:99:2: ( ( '!' ) itemcondition | itemcondition )
            int alt11=2;
            int LA11_0 = input.LA(1);

            if ( (LA11_0==28) ) {
                alt11=1;
            }
            else if ( (LA11_0==19||LA11_0==29) ) {
                alt11=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 11, 0, input);

                throw nvae;
            }
            switch (alt11) {
                case 1 :
                    // MeterSimulator.g:99:4: ( '!' ) itemcondition
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    // MeterSimulator.g:99:4: ( '!' )
                    // MeterSimulator.g:99:5: '!'
                    {
                    char_literal50=(Token)match(input,28,FOLLOW_28_in_notcondition344); 
                    char_literal50_tree = (CommonTree)adaptor.create(char_literal50);
                    root_0 = (CommonTree)adaptor.becomeRoot(char_literal50_tree, root_0);


                    }

                    pushFollow(FOLLOW_itemcondition_in_notcondition348);
                    itemcondition51=itemcondition();

                    state._fsp--;

                    adaptor.addChild(root_0, itemcondition51.getTree());

                    }
                    break;
                case 2 :
                    // MeterSimulator.g:100:4: itemcondition
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_itemcondition_in_notcondition353);
                    itemcondition52=itemcondition();

                    state._fsp--;

                    adaptor.addChild(root_0, itemcondition52.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        	catch (RecognitionException e) {
        	    throw e;
        	}
        finally {
        }
        return retval;
    }
    // $ANTLR end "notcondition"

    public static class itemcondition_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "itemcondition"
    // MeterSimulator.g:103:1: itemcondition : ( '(' condition ')' | comparecondition );
    public final MeterSimulatorParser.itemcondition_return itemcondition() throws RecognitionException {
        MeterSimulatorParser.itemcondition_return retval = new MeterSimulatorParser.itemcondition_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token char_literal53=null;
        Token char_literal55=null;
        MeterSimulatorParser.condition_return condition54 = null;

        MeterSimulatorParser.comparecondition_return comparecondition56 = null;


        CommonTree char_literal53_tree=null;
        CommonTree char_literal55_tree=null;

        try {
            // MeterSimulator.g:104:2: ( '(' condition ')' | comparecondition )
            int alt12=2;
            int LA12_0 = input.LA(1);

            if ( (LA12_0==19) ) {
                alt12=1;
            }
            else if ( (LA12_0==29) ) {
                alt12=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 12, 0, input);

                throw nvae;
            }
            switch (alt12) {
                case 1 :
                    // MeterSimulator.g:104:4: '(' condition ')'
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    char_literal53=(Token)match(input,19,FOLLOW_19_in_itemcondition364); 
                    pushFollow(FOLLOW_condition_in_itemcondition367);
                    condition54=condition();

                    state._fsp--;

                    adaptor.addChild(root_0, condition54.getTree());
                    char_literal55=(Token)match(input,20,FOLLOW_20_in_itemcondition369); 

                    }
                    break;
                case 2 :
                    // MeterSimulator.g:105:4: comparecondition
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_comparecondition_in_itemcondition375);
                    comparecondition56=comparecondition();

                    state._fsp--;

                    adaptor.addChild(root_0, comparecondition56.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        	catch (RecognitionException e) {
        	    throw e;
        	}
        finally {
        }
        return retval;
    }
    // $ANTLR end "itemcondition"

    public static class comparecondition_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "comparecondition"
    // MeterSimulator.g:108:1: comparecondition : '[' fourexpr ( '<' | '<=' | '>' | '>=' | '==' | '!=' ) fourexpr ']' ;
    public final MeterSimulatorParser.comparecondition_return comparecondition() throws RecognitionException {
        MeterSimulatorParser.comparecondition_return retval = new MeterSimulatorParser.comparecondition_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token char_literal57=null;
        Token char_literal59=null;
        Token string_literal60=null;
        Token char_literal61=null;
        Token string_literal62=null;
        Token string_literal63=null;
        Token string_literal64=null;
        Token char_literal66=null;
        MeterSimulatorParser.fourexpr_return fourexpr58 = null;

        MeterSimulatorParser.fourexpr_return fourexpr65 = null;


        CommonTree char_literal57_tree=null;
        CommonTree char_literal59_tree=null;
        CommonTree string_literal60_tree=null;
        CommonTree char_literal61_tree=null;
        CommonTree string_literal62_tree=null;
        CommonTree string_literal63_tree=null;
        CommonTree string_literal64_tree=null;
        CommonTree char_literal66_tree=null;

        try {
            // MeterSimulator.g:109:2: ( '[' fourexpr ( '<' | '<=' | '>' | '>=' | '==' | '!=' ) fourexpr ']' )
            // MeterSimulator.g:109:4: '[' fourexpr ( '<' | '<=' | '>' | '>=' | '==' | '!=' ) fourexpr ']'
            {
            root_0 = (CommonTree)adaptor.nil();

            char_literal57=(Token)match(input,29,FOLLOW_29_in_comparecondition386); 
            pushFollow(FOLLOW_fourexpr_in_comparecondition389);
            fourexpr58=fourexpr();

            state._fsp--;

            adaptor.addChild(root_0, fourexpr58.getTree());
            // MeterSimulator.g:109:18: ( '<' | '<=' | '>' | '>=' | '==' | '!=' )
            int alt13=6;
            switch ( input.LA(1) ) {
            case 30:
                {
                alt13=1;
                }
                break;
            case 31:
                {
                alt13=2;
                }
                break;
            case 32:
                {
                alt13=3;
                }
                break;
            case 33:
                {
                alt13=4;
                }
                break;
            case 34:
                {
                alt13=5;
                }
                break;
            case 35:
                {
                alt13=6;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 13, 0, input);

                throw nvae;
            }

            switch (alt13) {
                case 1 :
                    // MeterSimulator.g:109:19: '<'
                    {
                    char_literal59=(Token)match(input,30,FOLLOW_30_in_comparecondition392); 
                    char_literal59_tree = (CommonTree)adaptor.create(char_literal59);
                    root_0 = (CommonTree)adaptor.becomeRoot(char_literal59_tree, root_0);


                    }
                    break;
                case 2 :
                    // MeterSimulator.g:109:24: '<='
                    {
                    string_literal60=(Token)match(input,31,FOLLOW_31_in_comparecondition395); 
                    string_literal60_tree = (CommonTree)adaptor.create(string_literal60);
                    root_0 = (CommonTree)adaptor.becomeRoot(string_literal60_tree, root_0);


                    }
                    break;
                case 3 :
                    // MeterSimulator.g:109:30: '>'
                    {
                    char_literal61=(Token)match(input,32,FOLLOW_32_in_comparecondition398); 
                    char_literal61_tree = (CommonTree)adaptor.create(char_literal61);
                    root_0 = (CommonTree)adaptor.becomeRoot(char_literal61_tree, root_0);


                    }
                    break;
                case 4 :
                    // MeterSimulator.g:109:35: '>='
                    {
                    string_literal62=(Token)match(input,33,FOLLOW_33_in_comparecondition401); 
                    string_literal62_tree = (CommonTree)adaptor.create(string_literal62);
                    root_0 = (CommonTree)adaptor.becomeRoot(string_literal62_tree, root_0);


                    }
                    break;
                case 5 :
                    // MeterSimulator.g:109:41: '=='
                    {
                    string_literal63=(Token)match(input,34,FOLLOW_34_in_comparecondition404); 
                    string_literal63_tree = (CommonTree)adaptor.create(string_literal63);
                    root_0 = (CommonTree)adaptor.becomeRoot(string_literal63_tree, root_0);


                    }
                    break;
                case 6 :
                    // MeterSimulator.g:109:47: '!='
                    {
                    string_literal64=(Token)match(input,35,FOLLOW_35_in_comparecondition407); 
                    string_literal64_tree = (CommonTree)adaptor.create(string_literal64);
                    root_0 = (CommonTree)adaptor.becomeRoot(string_literal64_tree, root_0);


                    }
                    break;

            }

            pushFollow(FOLLOW_fourexpr_in_comparecondition411);
            fourexpr65=fourexpr();

            state._fsp--;

            adaptor.addChild(root_0, fourexpr65.getTree());
            char_literal66=(Token)match(input,36,FOLLOW_36_in_comparecondition413); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        	catch (RecognitionException e) {
        	    throw e;
        	}
        finally {
        }
        return retval;
    }
    // $ANTLR end "comparecondition"

    public static class func_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "func"
    // MeterSimulator.g:112:1: func : ( F0 '(' ')' | F1 '(' fourexpr ')' | F1DATE '(' fourexpr ')' | F2 '(' fourexpr ',' fourexpr ')' );
    public final MeterSimulatorParser.func_return func() throws RecognitionException {
        MeterSimulatorParser.func_return retval = new MeterSimulatorParser.func_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token F067=null;
        Token char_literal68=null;
        Token char_literal69=null;
        Token F170=null;
        Token char_literal71=null;
        Token char_literal73=null;
        Token F1DATE74=null;
        Token char_literal75=null;
        Token char_literal77=null;
        Token F278=null;
        Token char_literal79=null;
        Token char_literal81=null;
        Token char_literal83=null;
        MeterSimulatorParser.fourexpr_return fourexpr72 = null;

        MeterSimulatorParser.fourexpr_return fourexpr76 = null;

        MeterSimulatorParser.fourexpr_return fourexpr80 = null;

        MeterSimulatorParser.fourexpr_return fourexpr82 = null;


        CommonTree F067_tree=null;
        CommonTree char_literal68_tree=null;
        CommonTree char_literal69_tree=null;
        CommonTree F170_tree=null;
        CommonTree char_literal71_tree=null;
        CommonTree char_literal73_tree=null;
        CommonTree F1DATE74_tree=null;
        CommonTree char_literal75_tree=null;
        CommonTree char_literal77_tree=null;
        CommonTree F278_tree=null;
        CommonTree char_literal79_tree=null;
        CommonTree char_literal81_tree=null;
        CommonTree char_literal83_tree=null;

        try {
            // MeterSimulator.g:113:2: ( F0 '(' ')' | F1 '(' fourexpr ')' | F1DATE '(' fourexpr ')' | F2 '(' fourexpr ',' fourexpr ')' )
            int alt14=4;
            switch ( input.LA(1) ) {
            case F0:
                {
                alt14=1;
                }
                break;
            case F1:
                {
                alt14=2;
                }
                break;
            case F1DATE:
                {
                alt14=3;
                }
                break;
            case F2:
                {
                alt14=4;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 14, 0, input);

                throw nvae;
            }

            switch (alt14) {
                case 1 :
                    // MeterSimulator.g:113:4: F0 '(' ')'
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    F067=(Token)match(input,F0,FOLLOW_F0_in_func425); 
                    F067_tree = (CommonTree)adaptor.create(F067);
                    root_0 = (CommonTree)adaptor.becomeRoot(F067_tree, root_0);

                    char_literal68=(Token)match(input,19,FOLLOW_19_in_func428); 
                    char_literal69=(Token)match(input,20,FOLLOW_20_in_func431); 

                    }
                    break;
                case 2 :
                    // MeterSimulator.g:114:4: F1 '(' fourexpr ')'
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    F170=(Token)match(input,F1,FOLLOW_F1_in_func437); 
                    F170_tree = (CommonTree)adaptor.create(F170);
                    root_0 = (CommonTree)adaptor.becomeRoot(F170_tree, root_0);

                    char_literal71=(Token)match(input,19,FOLLOW_19_in_func440); 
                    pushFollow(FOLLOW_fourexpr_in_func443);
                    fourexpr72=fourexpr();

                    state._fsp--;

                    adaptor.addChild(root_0, fourexpr72.getTree());
                    char_literal73=(Token)match(input,20,FOLLOW_20_in_func445); 

                    }
                    break;
                case 3 :
                    // MeterSimulator.g:115:4: F1DATE '(' fourexpr ')'
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    F1DATE74=(Token)match(input,F1DATE,FOLLOW_F1DATE_in_func451); 
                    F1DATE74_tree = (CommonTree)adaptor.create(F1DATE74);
                    root_0 = (CommonTree)adaptor.becomeRoot(F1DATE74_tree, root_0);

                    char_literal75=(Token)match(input,19,FOLLOW_19_in_func454); 
                    pushFollow(FOLLOW_fourexpr_in_func457);
                    fourexpr76=fourexpr();

                    state._fsp--;

                    adaptor.addChild(root_0, fourexpr76.getTree());
                    char_literal77=(Token)match(input,20,FOLLOW_20_in_func459); 

                    }
                    break;
                case 4 :
                    // MeterSimulator.g:116:4: F2 '(' fourexpr ',' fourexpr ')'
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    F278=(Token)match(input,F2,FOLLOW_F2_in_func465); 
                    F278_tree = (CommonTree)adaptor.create(F278);
                    root_0 = (CommonTree)adaptor.becomeRoot(F278_tree, root_0);

                    char_literal79=(Token)match(input,19,FOLLOW_19_in_func468); 
                    pushFollow(FOLLOW_fourexpr_in_func471);
                    fourexpr80=fourexpr();

                    state._fsp--;

                    adaptor.addChild(root_0, fourexpr80.getTree());
                    char_literal81=(Token)match(input,37,FOLLOW_37_in_func473); 
                    pushFollow(FOLLOW_fourexpr_in_func476);
                    fourexpr82=fourexpr();

                    state._fsp--;

                    adaptor.addChild(root_0, fourexpr82.getTree());
                    char_literal83=(Token)match(input,20,FOLLOW_20_in_func478); 

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

        	catch (RecognitionException e) {
        	    throw e;
        	}
        finally {
        }
        return retval;
    }
    // $ANTLR end "func"

    // Delegated rules


 

    public static final BitSet FOLLOW_expr_in_prog82 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_NEWLINE_in_prog84 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_fourexpr_in_expr97 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ifcondition_in_expr102 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_multexpr_in_fourexpr113 = new BitSet(new long[]{0x000000000000C002L});
    public static final BitSet FOLLOW_14_in_fourexpr117 = new BitSet(new long[]{0x0000000000081FE0L});
    public static final BitSet FOLLOW_15_in_fourexpr120 = new BitSet(new long[]{0x0000000000081FE0L});
    public static final BitSet FOLLOW_multexpr_in_fourexpr124 = new BitSet(new long[]{0x000000000000C002L});
    public static final BitSet FOLLOW_atom_in_multexpr138 = new BitSet(new long[]{0x0000000000070002L});
    public static final BitSet FOLLOW_16_in_multexpr142 = new BitSet(new long[]{0x0000000000081FE0L});
    public static final BitSet FOLLOW_17_in_multexpr145 = new BitSet(new long[]{0x0000000000081FE0L});
    public static final BitSet FOLLOW_18_in_multexpr148 = new BitSet(new long[]{0x0000000000081FE0L});
    public static final BitSet FOLLOW_atom_in_multexpr152 = new BitSet(new long[]{0x0000000000070002L});
    public static final BitSet FOLLOW_DOUBLE_in_atom166 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INTEGER_in_atom171 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CONSTANT_in_atom176 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_atom181 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_func_in_atom186 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_19_in_atom192 = new BitSet(new long[]{0x0000000000081FE0L});
    public static final BitSet FOLLOW_fourexpr_in_atom195 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_20_in_atom197 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_21_in_ifcondition210 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_19_in_ifcondition213 = new BitSet(new long[]{0x0000000030080000L});
    public static final BitSet FOLLOW_condition_in_ifcondition216 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_20_in_ifcondition218 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_22_in_ifcondition221 = new BitSet(new long[]{0x0000000000281FE0L});
    public static final BitSet FOLLOW_expr_in_ifcondition224 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_23_in_ifcondition226 = new BitSet(new long[]{0x0000000003000000L});
    public static final BitSet FOLLOW_elseifcondition_in_ifcondition230 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_elsecondition_in_ifcondition232 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_24_in_elseifcondition244 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_19_in_elseifcondition247 = new BitSet(new long[]{0x0000000030080000L});
    public static final BitSet FOLLOW_condition_in_elseifcondition250 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_20_in_elseifcondition252 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_22_in_elseifcondition255 = new BitSet(new long[]{0x0000000000281FE0L});
    public static final BitSet FOLLOW_expr_in_elseifcondition258 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_23_in_elseifcondition260 = new BitSet(new long[]{0x0000000003000000L});
    public static final BitSet FOLLOW_elseifcondition_in_elseifcondition264 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_elsecondition_in_elseifcondition266 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_25_in_elsecondition279 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_22_in_elsecondition282 = new BitSet(new long[]{0x0000000000281FE0L});
    public static final BitSet FOLLOW_expr_in_elsecondition285 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_23_in_elsecondition287 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_andcondition_in_condition300 = new BitSet(new long[]{0x0000000004000002L});
    public static final BitSet FOLLOW_26_in_condition304 = new BitSet(new long[]{0x0000000030080000L});
    public static final BitSet FOLLOW_andcondition_in_condition308 = new BitSet(new long[]{0x0000000004000002L});
    public static final BitSet FOLLOW_notcondition_in_andcondition322 = new BitSet(new long[]{0x0000000008000002L});
    public static final BitSet FOLLOW_27_in_andcondition326 = new BitSet(new long[]{0x0000000030080000L});
    public static final BitSet FOLLOW_notcondition_in_andcondition330 = new BitSet(new long[]{0x0000000008000002L});
    public static final BitSet FOLLOW_28_in_notcondition344 = new BitSet(new long[]{0x0000000030080000L});
    public static final BitSet FOLLOW_itemcondition_in_notcondition348 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_itemcondition_in_notcondition353 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_19_in_itemcondition364 = new BitSet(new long[]{0x0000000030080000L});
    public static final BitSet FOLLOW_condition_in_itemcondition367 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_20_in_itemcondition369 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_comparecondition_in_itemcondition375 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_29_in_comparecondition386 = new BitSet(new long[]{0x0000000000081FE0L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition389 = new BitSet(new long[]{0x0000000FC0000000L});
    public static final BitSet FOLLOW_30_in_comparecondition392 = new BitSet(new long[]{0x0000000000081FE0L});
    public static final BitSet FOLLOW_31_in_comparecondition395 = new BitSet(new long[]{0x0000000000081FE0L});
    public static final BitSet FOLLOW_32_in_comparecondition398 = new BitSet(new long[]{0x0000000000081FE0L});
    public static final BitSet FOLLOW_33_in_comparecondition401 = new BitSet(new long[]{0x0000000000081FE0L});
    public static final BitSet FOLLOW_34_in_comparecondition404 = new BitSet(new long[]{0x0000000000081FE0L});
    public static final BitSet FOLLOW_35_in_comparecondition407 = new BitSet(new long[]{0x0000000000081FE0L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition411 = new BitSet(new long[]{0x0000001000000000L});
    public static final BitSet FOLLOW_36_in_comparecondition413 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_F0_in_func425 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_19_in_func428 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_20_in_func431 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_F1_in_func437 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_19_in_func440 = new BitSet(new long[]{0x0000000000081FE0L});
    public static final BitSet FOLLOW_fourexpr_in_func443 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_20_in_func445 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_F1DATE_in_func451 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_19_in_func454 = new BitSet(new long[]{0x0000000000081FE0L});
    public static final BitSet FOLLOW_fourexpr_in_func457 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_20_in_func459 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_F2_in_func465 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_19_in_func468 = new BitSet(new long[]{0x0000000000081FE0L});
    public static final BitSet FOLLOW_fourexpr_in_func471 = new BitSet(new long[]{0x0000002000000000L});
    public static final BitSet FOLLOW_37_in_func473 = new BitSet(new long[]{0x0000000000081FE0L});
    public static final BitSet FOLLOW_fourexpr_in_func476 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_20_in_func478 = new BitSet(new long[]{0x0000000000000002L});

}