// $ANTLR 3.1 MeterSimulatorWalker.g 2013-11-21 16:54:43

package com.persagy.simulator;

import java.util.Map;
import java.util.HashMap;

import com.persagy.entity.ValueObject;
import com.persagy.util.ValueObjectUtil;
import com.persagy.util.FunctionUtil;


import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;

public class MeterSimulatorWalker extends TreeParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "NEWLINE", "DOUBLE", "INTEGER", "CONSTANT", "ID", "F0", "F1", "F1DATE", "F2", "WS", "'+'", "'-'", "'*'", "'/'", "'%'", "'('", "')'", "'if'", "'{'", "'}'", "'elseif'", "'else'", "'||'", "'&&'", "'!'", "'['", "'<'", "'<='", "'>'", "'>='", "'=='", "'!='", "']'", "','"
    };
    public static final int INTEGER=6;
    public static final int T__29=29;
    public static final int T__28=28;
    public static final int T__27=27;
    public static final int T__26=26;
    public static final int T__25=25;
    public static final int T__24=24;
    public static final int T__23=23;
    public static final int T__22=22;
    public static final int T__21=21;
    public static final int T__20=20;
    public static final int ID=8;
    public static final int EOF=-1;
    public static final int T__30=30;
    public static final int T__19=19;
    public static final int T__31=31;
    public static final int T__32=32;
    public static final int T__16=16;
    public static final int T__33=33;
    public static final int WS=13;
    public static final int T__15=15;
    public static final int T__34=34;
    public static final int T__18=18;
    public static final int T__35=35;
    public static final int NEWLINE=4;
    public static final int T__17=17;
    public static final int T__36=36;
    public static final int T__37=37;
    public static final int T__14=14;
    public static final int F1=10;
    public static final int DOUBLE=5;
    public static final int CONSTANT=7;
    public static final int F0=9;
    public static final int F1DATE=11;
    public static final int F2=12;

    // delegates
    // delegators


        public MeterSimulatorWalker(TreeNodeStream input) {
            this(input, new RecognizerSharedState());
        }
        public MeterSimulatorWalker(TreeNodeStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return MeterSimulatorWalker.tokenNames; }
    public String getGrammarFileName() { return "MeterSimulatorWalker.g"; }


    	private Map<String,ValueObject> varValueMap=new HashMap<String,ValueObject>();
    	public void clear(){
    		this.varValueMap.clear();
    	}
    	public void put(String var,double value){
    		ValueObject valueObject=new ValueObject(value);
    		this.varValueMap.put(var,valueObject);
    	}
    	public void put(String var,long value){
    		ValueObject valueObject=new ValueObject(value);
    		this.varValueMap.put(var,valueObject);
    	}



    // $ANTLR start "prog"
    // MeterSimulatorWalker.g:37:1: prog returns [ValueObject value] : (a= expr ) ;
    public final ValueObject prog() throws RecognitionException {
        ValueObject value = null;

        ValueObject a = null;


        try {
            // MeterSimulatorWalker.g:38:2: ( (a= expr ) )
            // MeterSimulatorWalker.g:38:4: (a= expr )
            {
            // MeterSimulatorWalker.g:38:4: (a= expr )
            // MeterSimulatorWalker.g:38:5: a= expr
            {
            pushFollow(FOLLOW_expr_in_prog64);
            a=expr();

            state._fsp--;


            }

            value =a;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "prog"


    // $ANTLR start "expr"
    // MeterSimulatorWalker.g:41:1: expr returns [ValueObject value] : ( (a= fourexpr ) | (a= ifcondition ) );
    public final ValueObject expr() throws RecognitionException {
        ValueObject value = null;

        ValueObject a = null;


        try {
            // MeterSimulatorWalker.g:42:2: ( (a= fourexpr ) | (a= ifcondition ) )
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( ((LA1_0>=DOUBLE && LA1_0<=F2)||(LA1_0>=14 && LA1_0<=18)) ) {
                alt1=1;
            }
            else if ( (LA1_0==21) ) {
                alt1=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 1, 0, input);

                throw nvae;
            }
            switch (alt1) {
                case 1 :
                    // MeterSimulatorWalker.g:42:4: (a= fourexpr )
                    {
                    // MeterSimulatorWalker.g:42:4: (a= fourexpr )
                    // MeterSimulatorWalker.g:42:5: a= fourexpr
                    {
                    pushFollow(FOLLOW_fourexpr_in_expr86);
                    a=fourexpr();

                    state._fsp--;


                    }

                    value = a;

                    }
                    break;
                case 2 :
                    // MeterSimulatorWalker.g:43:4: (a= ifcondition )
                    {
                    // MeterSimulatorWalker.g:43:4: (a= ifcondition )
                    // MeterSimulatorWalker.g:43:5: a= ifcondition
                    {
                    pushFollow(FOLLOW_ifcondition_in_expr97);
                    a=ifcondition();

                    state._fsp--;


                    }

                    value = a;

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "expr"


    // $ANTLR start "fourexpr"
    // MeterSimulatorWalker.g:46:1: fourexpr returns [ValueObject value] : ( ^( '+' a= fourexpr b= fourexpr ) | ^( '-' a= fourexpr b= fourexpr ) | ^( '*' a= fourexpr b= fourexpr ) | ^( '/' a= fourexpr b= fourexpr ) | ^( '%' a= fourexpr b= fourexpr ) | CONSTANT | ID | F0 | ^( F1 a= fourexpr ) | ^( F1DATE a= fourexpr ) | ^( F2 a= fourexpr b= fourexpr ) | DOUBLE | INTEGER );
    public final ValueObject fourexpr() throws RecognitionException {
        ValueObject value = null;

        CommonTree CONSTANT1=null;
        CommonTree ID2=null;
        CommonTree F03=null;
        CommonTree F14=null;
        CommonTree F1DATE5=null;
        CommonTree F26=null;
        CommonTree DOUBLE7=null;
        CommonTree INTEGER8=null;
        ValueObject a = null;

        ValueObject b = null;


        try {
            // MeterSimulatorWalker.g:47:2: ( ^( '+' a= fourexpr b= fourexpr ) | ^( '-' a= fourexpr b= fourexpr ) | ^( '*' a= fourexpr b= fourexpr ) | ^( '/' a= fourexpr b= fourexpr ) | ^( '%' a= fourexpr b= fourexpr ) | CONSTANT | ID | F0 | ^( F1 a= fourexpr ) | ^( F1DATE a= fourexpr ) | ^( F2 a= fourexpr b= fourexpr ) | DOUBLE | INTEGER )
            int alt2=13;
            switch ( input.LA(1) ) {
            case 14:
                {
                alt2=1;
                }
                break;
            case 15:
                {
                alt2=2;
                }
                break;
            case 16:
                {
                alt2=3;
                }
                break;
            case 17:
                {
                alt2=4;
                }
                break;
            case 18:
                {
                alt2=5;
                }
                break;
            case CONSTANT:
                {
                alt2=6;
                }
                break;
            case ID:
                {
                alt2=7;
                }
                break;
            case F0:
                {
                alt2=8;
                }
                break;
            case F1:
                {
                alt2=9;
                }
                break;
            case F1DATE:
                {
                alt2=10;
                }
                break;
            case F2:
                {
                alt2=11;
                }
                break;
            case DOUBLE:
                {
                alt2=12;
                }
                break;
            case INTEGER:
                {
                alt2=13;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // MeterSimulatorWalker.g:47:4: ^( '+' a= fourexpr b= fourexpr )
                    {
                    match(input,14,FOLLOW_14_in_fourexpr116); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_fourexpr120);
                    a=fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_fourexpr124);
                    b=fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 
                    value = ValueObjectUtil.compute("+",a,b);

                    }
                    break;
                case 2 :
                    // MeterSimulatorWalker.g:48:4: ^( '-' a= fourexpr b= fourexpr )
                    {
                    match(input,15,FOLLOW_15_in_fourexpr133); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_fourexpr137);
                    a=fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_fourexpr141);
                    b=fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 
                    value = ValueObjectUtil.compute("-",a,b);

                    }
                    break;
                case 3 :
                    // MeterSimulatorWalker.g:49:4: ^( '*' a= fourexpr b= fourexpr )
                    {
                    match(input,16,FOLLOW_16_in_fourexpr150); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_fourexpr154);
                    a=fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_fourexpr158);
                    b=fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 
                    value = ValueObjectUtil.compute("*",a,b);

                    }
                    break;
                case 4 :
                    // MeterSimulatorWalker.g:50:4: ^( '/' a= fourexpr b= fourexpr )
                    {
                    match(input,17,FOLLOW_17_in_fourexpr167); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_fourexpr171);
                    a=fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_fourexpr175);
                    b=fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 
                    value = ValueObjectUtil.compute("/",a,b);

                    }
                    break;
                case 5 :
                    // MeterSimulatorWalker.g:51:4: ^( '%' a= fourexpr b= fourexpr )
                    {
                    match(input,18,FOLLOW_18_in_fourexpr184); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_fourexpr188);
                    a=fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_fourexpr192);
                    b=fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 
                    value = ValueObjectUtil.compute("%",a,b);

                    }
                    break;
                case 6 :
                    // MeterSimulatorWalker.g:52:4: CONSTANT
                    {
                    CONSTANT1=(CommonTree)match(input,CONSTANT,FOLLOW_CONSTANT_in_fourexpr200); 
                    value = FunctionUtil.constant((CONSTANT1!=null?CONSTANT1.getText():null));

                    }
                    break;
                case 7 :
                    // MeterSimulatorWalker.g:53:4: ID
                    {
                    ID2=(CommonTree)match(input,ID,FOLLOW_ID_in_fourexpr207); 
                    value = this.varValueMap.get((ID2!=null?ID2.getText():null));

                    }
                    break;
                case 8 :
                    // MeterSimulatorWalker.g:54:4: F0
                    {
                    F03=(CommonTree)match(input,F0,FOLLOW_F0_in_fourexpr214); 
                    value = FunctionUtil.compute((F03!=null?F03.getText():null));

                    }
                    break;
                case 9 :
                    // MeterSimulatorWalker.g:55:4: ^( F1 a= fourexpr )
                    {
                    F14=(CommonTree)match(input,F1,FOLLOW_F1_in_fourexpr222); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_fourexpr226);
                    a=fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 
                    value = FunctionUtil.compute((F14!=null?F14.getText():null),a);

                    }
                    break;
                case 10 :
                    // MeterSimulatorWalker.g:56:4: ^( F1DATE a= fourexpr )
                    {
                    F1DATE5=(CommonTree)match(input,F1DATE,FOLLOW_F1DATE_in_fourexpr235); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_fourexpr239);
                    a=fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 
                    value = FunctionUtil.computedate((F1DATE5!=null?F1DATE5.getText():null),a);

                    }
                    break;
                case 11 :
                    // MeterSimulatorWalker.g:57:4: ^( F2 a= fourexpr b= fourexpr )
                    {
                    F26=(CommonTree)match(input,F2,FOLLOW_F2_in_fourexpr248); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_fourexpr252);
                    a=fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_fourexpr256);
                    b=fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 
                    value = FunctionUtil.compute((F26!=null?F26.getText():null),a,b);

                    }
                    break;
                case 12 :
                    // MeterSimulatorWalker.g:58:4: DOUBLE
                    {
                    DOUBLE7=(CommonTree)match(input,DOUBLE,FOLLOW_DOUBLE_in_fourexpr264); 
                    value = new ValueObject((DOUBLE7!=null?DOUBLE7.getText():null));

                    }
                    break;
                case 13 :
                    // MeterSimulatorWalker.g:59:4: INTEGER
                    {
                    INTEGER8=(CommonTree)match(input,INTEGER,FOLLOW_INTEGER_in_fourexpr272); 
                    value = new ValueObject((INTEGER8!=null?INTEGER8.getText():null));

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "fourexpr"


    // $ANTLR start "ifcondition"
    // MeterSimulatorWalker.g:62:1: ifcondition returns [ValueObject value] : ^( 'if' con= condition a= expr b= elseifcondition ) ;
    public final ValueObject ifcondition() throws RecognitionException {
        ValueObject value = null;

        boolean con = false;

        ValueObject a = null;

        ValueObject b = null;


        try {
            // MeterSimulatorWalker.g:63:2: ( ^( 'if' con= condition a= expr b= elseifcondition ) )
            // MeterSimulatorWalker.g:63:4: ^( 'if' con= condition a= expr b= elseifcondition )
            {
            match(input,21,FOLLOW_21_in_ifcondition292); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_condition_in_ifcondition296);
            con=condition();

            state._fsp--;

            pushFollow(FOLLOW_expr_in_ifcondition300);
            a=expr();

            state._fsp--;

            pushFollow(FOLLOW_elseifcondition_in_ifcondition304);
            b=elseifcondition();

            state._fsp--;


            match(input, Token.UP, null); 
            if(con)value = a;else value =b;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "ifcondition"


    // $ANTLR start "elseifcondition"
    // MeterSimulatorWalker.g:66:1: elseifcondition returns [ValueObject value] : ( ^( 'elseif' con= condition a= expr b= elseifcondition ) | ^( 'else' a= expr ) );
    public final ValueObject elseifcondition() throws RecognitionException {
        ValueObject value = null;

        boolean con = false;

        ValueObject a = null;

        ValueObject b = null;


        try {
            // MeterSimulatorWalker.g:67:2: ( ^( 'elseif' con= condition a= expr b= elseifcondition ) | ^( 'else' a= expr ) )
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==24) ) {
                alt3=1;
            }
            else if ( (LA3_0==25) ) {
                alt3=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 3, 0, input);

                throw nvae;
            }
            switch (alt3) {
                case 1 :
                    // MeterSimulatorWalker.g:67:4: ^( 'elseif' con= condition a= expr b= elseifcondition )
                    {
                    match(input,24,FOLLOW_24_in_elseifcondition323); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_condition_in_elseifcondition327);
                    con=condition();

                    state._fsp--;

                    pushFollow(FOLLOW_expr_in_elseifcondition331);
                    a=expr();

                    state._fsp--;

                    pushFollow(FOLLOW_elseifcondition_in_elseifcondition335);
                    b=elseifcondition();

                    state._fsp--;


                    match(input, Token.UP, null); 
                    if(con)value = a;else value =b;

                    }
                    break;
                case 2 :
                    // MeterSimulatorWalker.g:68:4: ^( 'else' a= expr )
                    {
                    match(input,25,FOLLOW_25_in_elseifcondition344); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_elseifcondition348);
                    a=expr();

                    state._fsp--;


                    match(input, Token.UP, null); 
                    value = a;

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "elseifcondition"


    // $ANTLR start "condition"
    // MeterSimulatorWalker.g:71:1: condition returns [boolean value] : ( ^( '&&' a= condition b= condition ) | ^( '||' a= condition b= condition ) | ^( '!' a= condition ) | (a= comparecondition ) );
    public final boolean condition() throws RecognitionException {
        boolean value = false;

        boolean a = false;

        boolean b = false;


        try {
            // MeterSimulatorWalker.g:72:2: ( ^( '&&' a= condition b= condition ) | ^( '||' a= condition b= condition ) | ^( '!' a= condition ) | (a= comparecondition ) )
            int alt4=4;
            switch ( input.LA(1) ) {
            case 27:
                {
                alt4=1;
                }
                break;
            case 26:
                {
                alt4=2;
                }
                break;
            case 28:
                {
                alt4=3;
                }
                break;
            case 30:
            case 31:
            case 32:
            case 33:
            case 34:
            case 35:
                {
                alt4=4;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 4, 0, input);

                throw nvae;
            }

            switch (alt4) {
                case 1 :
                    // MeterSimulatorWalker.g:72:4: ^( '&&' a= condition b= condition )
                    {
                    match(input,27,FOLLOW_27_in_condition367); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_condition_in_condition371);
                    a=condition();

                    state._fsp--;

                    pushFollow(FOLLOW_condition_in_condition375);
                    b=condition();

                    state._fsp--;


                    match(input, Token.UP, null); 
                    value = a && b;

                    }
                    break;
                case 2 :
                    // MeterSimulatorWalker.g:73:4: ^( '||' a= condition b= condition )
                    {
                    match(input,26,FOLLOW_26_in_condition384); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_condition_in_condition388);
                    a=condition();

                    state._fsp--;

                    pushFollow(FOLLOW_condition_in_condition392);
                    b=condition();

                    state._fsp--;


                    match(input, Token.UP, null); 
                    value = a || b;

                    }
                    break;
                case 3 :
                    // MeterSimulatorWalker.g:74:4: ^( '!' a= condition )
                    {
                    match(input,28,FOLLOW_28_in_condition401); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_condition_in_condition405);
                    a=condition();

                    state._fsp--;


                    match(input, Token.UP, null); 
                    value = !a;

                    }
                    break;
                case 4 :
                    // MeterSimulatorWalker.g:75:4: (a= comparecondition )
                    {
                    // MeterSimulatorWalker.g:75:4: (a= comparecondition )
                    // MeterSimulatorWalker.g:75:5: a= comparecondition
                    {
                    pushFollow(FOLLOW_comparecondition_in_condition417);
                    a=comparecondition();

                    state._fsp--;


                    }

                    value = a;

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "condition"


    // $ANTLR start "comparecondition"
    // MeterSimulatorWalker.g:78:1: comparecondition returns [boolean value] : ( ^( '<' a= fourexpr b= fourexpr ) | ^( '<=' a= fourexpr b= fourexpr ) | ^( '>' a= fourexpr b= fourexpr ) | ^( '>=' a= fourexpr b= fourexpr ) | ^( '==' a= fourexpr b= fourexpr ) | ^( '!=' a= fourexpr b= fourexpr ) );
    public final boolean comparecondition() throws RecognitionException {
        boolean value = false;

        ValueObject a = null;

        ValueObject b = null;


        try {
            // MeterSimulatorWalker.g:79:2: ( ^( '<' a= fourexpr b= fourexpr ) | ^( '<=' a= fourexpr b= fourexpr ) | ^( '>' a= fourexpr b= fourexpr ) | ^( '>=' a= fourexpr b= fourexpr ) | ^( '==' a= fourexpr b= fourexpr ) | ^( '!=' a= fourexpr b= fourexpr ) )
            int alt5=6;
            switch ( input.LA(1) ) {
            case 30:
                {
                alt5=1;
                }
                break;
            case 31:
                {
                alt5=2;
                }
                break;
            case 32:
                {
                alt5=3;
                }
                break;
            case 33:
                {
                alt5=4;
                }
                break;
            case 34:
                {
                alt5=5;
                }
                break;
            case 35:
                {
                alt5=6;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 5, 0, input);

                throw nvae;
            }

            switch (alt5) {
                case 1 :
                    // MeterSimulatorWalker.g:79:4: ^( '<' a= fourexpr b= fourexpr )
                    {
                    match(input,30,FOLLOW_30_in_comparecondition436); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_comparecondition440);
                    a=fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_comparecondition444);
                    b=fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 
                    value = ValueObjectUtil.compare("<",a,b);

                    }
                    break;
                case 2 :
                    // MeterSimulatorWalker.g:80:4: ^( '<=' a= fourexpr b= fourexpr )
                    {
                    match(input,31,FOLLOW_31_in_comparecondition453); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_comparecondition457);
                    a=fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_comparecondition461);
                    b=fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 
                    value = ValueObjectUtil.compare("<=",a,b);

                    }
                    break;
                case 3 :
                    // MeterSimulatorWalker.g:81:4: ^( '>' a= fourexpr b= fourexpr )
                    {
                    match(input,32,FOLLOW_32_in_comparecondition470); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_comparecondition474);
                    a=fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_comparecondition478);
                    b=fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 
                    value = ValueObjectUtil.compare(">",a,b);

                    }
                    break;
                case 4 :
                    // MeterSimulatorWalker.g:82:4: ^( '>=' a= fourexpr b= fourexpr )
                    {
                    match(input,33,FOLLOW_33_in_comparecondition487); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_comparecondition491);
                    a=fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_comparecondition495);
                    b=fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 
                    value = ValueObjectUtil.compare(">=",a,b);

                    }
                    break;
                case 5 :
                    // MeterSimulatorWalker.g:83:4: ^( '==' a= fourexpr b= fourexpr )
                    {
                    match(input,34,FOLLOW_34_in_comparecondition504); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_comparecondition508);
                    a=fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_comparecondition512);
                    b=fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 
                    value = ValueObjectUtil.compare("==",a,b);

                    }
                    break;
                case 6 :
                    // MeterSimulatorWalker.g:84:4: ^( '!=' a= fourexpr b= fourexpr )
                    {
                    match(input,35,FOLLOW_35_in_comparecondition521); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_comparecondition525);
                    a=fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_comparecondition529);
                    b=fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 
                    value = ValueObjectUtil.compare("!=",a,b);

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "comparecondition"

    // Delegated rules


 

    public static final BitSet FOLLOW_expr_in_prog64 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_fourexpr_in_expr86 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ifcondition_in_expr97 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_14_in_fourexpr116 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr120 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr124 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_15_in_fourexpr133 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr137 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr141 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_16_in_fourexpr150 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr154 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr158 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_17_in_fourexpr167 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr171 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr175 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_18_in_fourexpr184 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr188 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr192 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_CONSTANT_in_fourexpr200 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_fourexpr207 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_F0_in_fourexpr214 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_F1_in_fourexpr222 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr226 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_F1DATE_in_fourexpr235 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr239 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_F2_in_fourexpr248 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr252 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr256 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DOUBLE_in_fourexpr264 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INTEGER_in_fourexpr272 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_21_in_ifcondition292 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_condition_in_ifcondition296 = new BitSet(new long[]{0x000000000027DFE0L});
    public static final BitSet FOLLOW_expr_in_ifcondition300 = new BitSet(new long[]{0x0000000003000000L});
    public static final BitSet FOLLOW_elseifcondition_in_ifcondition304 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_24_in_elseifcondition323 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_condition_in_elseifcondition327 = new BitSet(new long[]{0x000000000027DFE0L});
    public static final BitSet FOLLOW_expr_in_elseifcondition331 = new BitSet(new long[]{0x0000000003000000L});
    public static final BitSet FOLLOW_elseifcondition_in_elseifcondition335 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_25_in_elseifcondition344 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_elseifcondition348 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_27_in_condition367 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_condition_in_condition371 = new BitSet(new long[]{0x0000000FDC000000L});
    public static final BitSet FOLLOW_condition_in_condition375 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_26_in_condition384 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_condition_in_condition388 = new BitSet(new long[]{0x0000000FDC000000L});
    public static final BitSet FOLLOW_condition_in_condition392 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_28_in_condition401 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_condition_in_condition405 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_comparecondition_in_condition417 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_30_in_comparecondition436 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition440 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition444 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_31_in_comparecondition453 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition457 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition461 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_32_in_comparecondition470 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition474 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition478 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_33_in_comparecondition487 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition491 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition495 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_34_in_comparecondition504 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition508 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition512 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_35_in_comparecondition521 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition525 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition529 = new BitSet(new long[]{0x0000000000000008L});

}