package com.persagy.simulator_gaopin;

import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

public class BKDRHash {
	public static int seed = 31;

	public static int getHashCode(String str) {
		int hash = 0;
		for (int i = 0; i != str.length(); ++i) {
			hash = seed * hash + str.charAt(i);
		}
		return hash;
	}

	public static int getRemain(int value, int chushu) {
		int yushu = value % chushu;
		if (yushu < 0) {
			yushu = 0 - yushu;
		}
		return yushu;
	}

	public static void main(String[] args) {
		int length = 100000;
		String str1 = "http://blog.csdn.net/bojie5744";
		System.out.println("str1 :" + str1.hashCode() + " system");
		System.out.println("str1 :" + getHashCode(str1) + " custom");

		Map<String, String> map = new HashMap<String, String>();
		for (int i = 0; i != length; ++i) {
			String str = UUID.randomUUID().toString();
			map.put(getHashCode(str) + "", str);
		}
		System.out.println("冲突数为： " + (length - map.size()));
	}

}
