package com.persagy.util;

import java.util.Random;

public class PacketNumGenerator {
	private static final PacketNumGenerator INSTANCE = new PacketNumGenerator();
	int num = 1;

	private PacketNumGenerator() {
		Random rand = new Random();
		num = 1 + rand.nextInt(100);
	}

	public synchronized static PacketNumGenerator Instance() {
		return INSTANCE;
	}

	public synchronized int Generate() {
		num++;
		if (num >= 2147483647) {
			num = 1;
		}
		return num;
	}
}
