package com.persagy.communication.entity;

import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSONObject;

import java.util.Date;

public class Packet {
    public String packetString;
    public byte[] packetBytes;
    public Date time = new Date();

    public Packet(String packetString) {
        this.packetString = StrUtil.trim(packetString);
    }

    public Packet(byte[] packetBytes) {
        this.packetBytes = packetBytes;
    }

    public Packet() {
    }

    public String getPacketString() {
        return packetString;
    }

    public void setPacketString(String packetString) {
        this.packetString = StrUtil.trim(packetString);
    }

    public byte[] getPacketBytes() {
        return packetBytes;
    }

    public void setPacketBytes(byte[] packetBytes) {
        this.packetBytes = packetBytes;
    }

    public Date getTime() {
        return time;
    }

    public void setTime(Date time) {
        this.time = time;
    }

    @Override
    public String toString() {
        return JSONObject.toJSONString(this);
    }
}
