package com.persagy.communication.util;

import com.persagy.communication.entity.Packet;

public interface IClientManager {

    String Name();

    void Start();

    void Stop();

    boolean IsSessionClosed();

    void SetSessionClosed(boolean value);

    void AppendToSend(Packet MyPackage);

    Packet PopRece();

    Packet takeRece() throws InterruptedException;

    int ReceBufferSize();

    void setHandlerManager(IClientHandler handlerManager);

    void hasRemark(int count);
}
