package com.persagy.entity;

public class ValueObject {
	public ValueObject() {

	}

	public ValueObject(long value) {
		this.intValue = value;
	}

	public ValueObject(double value) {
		this.doubleValue = value;
		this.type = 1;
	}

	public ValueObject(String text) {
		try {
			this.intValue = Long.parseLong(text);
		} catch (Exception e) {
			this.doubleValue = Double.parseDouble(text);
			this.type = 1;
		}
	}

	public int type;// 0:int;1:double
	public long intValue;
	public double doubleValue;
}
