// $ANTLR 3.1 MeterSimulatorScanner.g 2013-11-21 16:54:43

package com.persagy.simulator;

import java.util.Map;
import java.util.HashMap;


import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;

public class MeterSimulatorScanner extends TreeParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "NEWLINE", "DOUBLE", "INTEGER", "CONSTANT", "ID", "F0", "F1", "F1DATE", "F2", "WS", "'+'", "'-'", "'*'", "'/'", "'%'", "'('", "')'", "'if'", "'{'", "'}'", "'elseif'", "'else'", "'||'", "'&&'", "'!'", "'['", "'<'", "'<='", "'>'", "'>='", "'=='", "'!='", "']'", "','"
    };
    public static final int INTEGER=6;
    public static final int T__29=29;
    public static final int T__28=28;
    public static final int T__27=27;
    public static final int T__26=26;
    public static final int T__25=25;
    public static final int T__24=24;
    public static final int T__23=23;
    public static final int T__22=22;
    public static final int T__21=21;
    public static final int T__20=20;
    public static final int ID=8;
    public static final int EOF=-1;
    public static final int T__30=30;
    public static final int T__19=19;
    public static final int T__31=31;
    public static final int T__32=32;
    public static final int T__16=16;
    public static final int T__33=33;
    public static final int WS=13;
    public static final int T__15=15;
    public static final int T__34=34;
    public static final int T__18=18;
    public static final int T__35=35;
    public static final int NEWLINE=4;
    public static final int T__17=17;
    public static final int T__36=36;
    public static final int T__37=37;
    public static final int T__14=14;
    public static final int F1=10;
    public static final int DOUBLE=5;
    public static final int CONSTANT=7;
    public static final int F0=9;
    public static final int F1DATE=11;
    public static final int F2=12;

    // delegates
    // delegators


        public MeterSimulatorScanner(TreeNodeStream input) {
            this(input, new RecognizerSharedState());
        }
        public MeterSimulatorScanner(TreeNodeStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return MeterSimulatorScanner.tokenNames; }
    public String getGrammarFileName() { return "MeterSimulatorScanner.g"; }


    	public Map<String, Boolean> varDict = new HashMap<String, Boolean>();
    	private void AddVar(String var)
    	{	
    		if(!this.varDict.containsKey(var))
    		{
    			this.varDict.put(var,true);
    		}
    	}



    // $ANTLR start "prog"
    // MeterSimulatorScanner.g:29:1: prog : (a= expr ) ;
    public final void prog() throws RecognitionException {
        try {
            // MeterSimulatorScanner.g:30:2: ( (a= expr ) )
            // MeterSimulatorScanner.g:30:4: (a= expr )
            {
            // MeterSimulatorScanner.g:30:4: (a= expr )
            // MeterSimulatorScanner.g:30:5: a= expr
            {
            pushFollow(FOLLOW_expr_in_prog60);
            expr();

            state._fsp--;


            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "prog"


    // $ANTLR start "expr"
    // MeterSimulatorScanner.g:33:1: expr : ( (a= fourexpr ) | (a= ifcondition ) );
    public final void expr() throws RecognitionException {
        try {
            // MeterSimulatorScanner.g:34:2: ( (a= fourexpr ) | (a= ifcondition ) )
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( ((LA1_0>=DOUBLE && LA1_0<=F2)||(LA1_0>=14 && LA1_0<=18)) ) {
                alt1=1;
            }
            else if ( (LA1_0==21) ) {
                alt1=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 1, 0, input);

                throw nvae;
            }
            switch (alt1) {
                case 1 :
                    // MeterSimulatorScanner.g:34:4: (a= fourexpr )
                    {
                    // MeterSimulatorScanner.g:34:4: (a= fourexpr )
                    // MeterSimulatorScanner.g:34:5: a= fourexpr
                    {
                    pushFollow(FOLLOW_fourexpr_in_expr76);
                    fourexpr();

                    state._fsp--;


                    }


                    }
                    break;
                case 2 :
                    // MeterSimulatorScanner.g:35:4: (a= ifcondition )
                    {
                    // MeterSimulatorScanner.g:35:4: (a= ifcondition )
                    // MeterSimulatorScanner.g:35:5: a= ifcondition
                    {
                    pushFollow(FOLLOW_ifcondition_in_expr85);
                    ifcondition();

                    state._fsp--;


                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "expr"


    // $ANTLR start "fourexpr"
    // MeterSimulatorScanner.g:38:1: fourexpr : ( ^( '+' a= fourexpr b= fourexpr ) | ^( '-' a= fourexpr b= fourexpr ) | ^( '*' a= fourexpr b= fourexpr ) | ^( '/' a= fourexpr b= fourexpr ) | ^( '%' a= fourexpr b= fourexpr ) | CONSTANT | ID | F0 | ^( F1 a= fourexpr ) | ^( F1DATE a= fourexpr ) | ^( F2 a= fourexpr b= fourexpr ) | DOUBLE | INTEGER );
    public final void fourexpr() throws RecognitionException {
        CommonTree ID1=null;

        try {
            // MeterSimulatorScanner.g:39:2: ( ^( '+' a= fourexpr b= fourexpr ) | ^( '-' a= fourexpr b= fourexpr ) | ^( '*' a= fourexpr b= fourexpr ) | ^( '/' a= fourexpr b= fourexpr ) | ^( '%' a= fourexpr b= fourexpr ) | CONSTANT | ID | F0 | ^( F1 a= fourexpr ) | ^( F1DATE a= fourexpr ) | ^( F2 a= fourexpr b= fourexpr ) | DOUBLE | INTEGER )
            int alt2=13;
            switch ( input.LA(1) ) {
            case 14:
                {
                alt2=1;
                }
                break;
            case 15:
                {
                alt2=2;
                }
                break;
            case 16:
                {
                alt2=3;
                }
                break;
            case 17:
                {
                alt2=4;
                }
                break;
            case 18:
                {
                alt2=5;
                }
                break;
            case CONSTANT:
                {
                alt2=6;
                }
                break;
            case ID:
                {
                alt2=7;
                }
                break;
            case F0:
                {
                alt2=8;
                }
                break;
            case F1:
                {
                alt2=9;
                }
                break;
            case F1DATE:
                {
                alt2=10;
                }
                break;
            case F2:
                {
                alt2=11;
                }
                break;
            case DOUBLE:
                {
                alt2=12;
                }
                break;
            case INTEGER:
                {
                alt2=13;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // MeterSimulatorScanner.g:39:4: ^( '+' a= fourexpr b= fourexpr )
                    {
                    match(input,14,FOLLOW_14_in_fourexpr98); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_fourexpr102);
                    fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_fourexpr106);
                    fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 2 :
                    // MeterSimulatorScanner.g:40:4: ^( '-' a= fourexpr b= fourexpr )
                    {
                    match(input,15,FOLLOW_15_in_fourexpr113); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_fourexpr117);
                    fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_fourexpr121);
                    fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 3 :
                    // MeterSimulatorScanner.g:41:4: ^( '*' a= fourexpr b= fourexpr )
                    {
                    match(input,16,FOLLOW_16_in_fourexpr128); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_fourexpr132);
                    fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_fourexpr136);
                    fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 4 :
                    // MeterSimulatorScanner.g:42:4: ^( '/' a= fourexpr b= fourexpr )
                    {
                    match(input,17,FOLLOW_17_in_fourexpr143); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_fourexpr147);
                    fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_fourexpr151);
                    fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 5 :
                    // MeterSimulatorScanner.g:43:4: ^( '%' a= fourexpr b= fourexpr )
                    {
                    match(input,18,FOLLOW_18_in_fourexpr158); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_fourexpr162);
                    fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_fourexpr166);
                    fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 6 :
                    // MeterSimulatorScanner.g:44:4: CONSTANT
                    {
                    match(input,CONSTANT,FOLLOW_CONSTANT_in_fourexpr172); 

                    }
                    break;
                case 7 :
                    // MeterSimulatorScanner.g:45:4: ID
                    {
                    ID1=(CommonTree)match(input,ID,FOLLOW_ID_in_fourexpr177); 
                    this.AddVar((ID1!=null?ID1.getText():null));

                    }
                    break;
                case 8 :
                    // MeterSimulatorScanner.g:46:4: F0
                    {
                    match(input,F0,FOLLOW_F0_in_fourexpr184); 

                    }
                    break;
                case 9 :
                    // MeterSimulatorScanner.g:47:4: ^( F1 a= fourexpr )
                    {
                    match(input,F1,FOLLOW_F1_in_fourexpr190); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_fourexpr194);
                    fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 10 :
                    // MeterSimulatorScanner.g:48:4: ^( F1DATE a= fourexpr )
                    {
                    match(input,F1DATE,FOLLOW_F1DATE_in_fourexpr201); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_fourexpr205);
                    fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 11 :
                    // MeterSimulatorScanner.g:49:4: ^( F2 a= fourexpr b= fourexpr )
                    {
                    match(input,F2,FOLLOW_F2_in_fourexpr212); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_fourexpr216);
                    fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_fourexpr220);
                    fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 12 :
                    // MeterSimulatorScanner.g:50:4: DOUBLE
                    {
                    match(input,DOUBLE,FOLLOW_DOUBLE_in_fourexpr226); 

                    }
                    break;
                case 13 :
                    // MeterSimulatorScanner.g:51:4: INTEGER
                    {
                    match(input,INTEGER,FOLLOW_INTEGER_in_fourexpr231); 

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "fourexpr"


    // $ANTLR start "ifcondition"
    // MeterSimulatorScanner.g:54:1: ifcondition : ^( 'if' con= condition a= expr b= elseifcondition ) ;
    public final void ifcondition() throws RecognitionException {
        try {
            // MeterSimulatorScanner.g:55:2: ( ^( 'if' con= condition a= expr b= elseifcondition ) )
            // MeterSimulatorScanner.g:55:4: ^( 'if' con= condition a= expr b= elseifcondition )
            {
            match(input,21,FOLLOW_21_in_ifcondition244); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_condition_in_ifcondition248);
            condition();

            state._fsp--;

            pushFollow(FOLLOW_expr_in_ifcondition252);
            expr();

            state._fsp--;

            pushFollow(FOLLOW_elseifcondition_in_ifcondition256);
            elseifcondition();

            state._fsp--;


            match(input, Token.UP, null); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "ifcondition"


    // $ANTLR start "elseifcondition"
    // MeterSimulatorScanner.g:58:1: elseifcondition : ( ^( 'elseif' con= condition a= expr b= elseifcondition ) | ^( 'else' a= expr ) );
    public final void elseifcondition() throws RecognitionException {
        try {
            // MeterSimulatorScanner.g:59:2: ( ^( 'elseif' con= condition a= expr b= elseifcondition ) | ^( 'else' a= expr ) )
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==24) ) {
                alt3=1;
            }
            else if ( (LA3_0==25) ) {
                alt3=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 3, 0, input);

                throw nvae;
            }
            switch (alt3) {
                case 1 :
                    // MeterSimulatorScanner.g:59:4: ^( 'elseif' con= condition a= expr b= elseifcondition )
                    {
                    match(input,24,FOLLOW_24_in_elseifcondition269); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_condition_in_elseifcondition273);
                    condition();

                    state._fsp--;

                    pushFollow(FOLLOW_expr_in_elseifcondition277);
                    expr();

                    state._fsp--;

                    pushFollow(FOLLOW_elseifcondition_in_elseifcondition281);
                    elseifcondition();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 2 :
                    // MeterSimulatorScanner.g:60:4: ^( 'else' a= expr )
                    {
                    match(input,25,FOLLOW_25_in_elseifcondition288); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_elseifcondition292);
                    expr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "elseifcondition"


    // $ANTLR start "condition"
    // MeterSimulatorScanner.g:63:1: condition : ( ^( '&&' a= condition b= condition ) | ^( '||' a= condition b= condition ) | ^( '!' a= condition ) | (a= comparecondition ) );
    public final void condition() throws RecognitionException {
        try {
            // MeterSimulatorScanner.g:64:2: ( ^( '&&' a= condition b= condition ) | ^( '||' a= condition b= condition ) | ^( '!' a= condition ) | (a= comparecondition ) )
            int alt4=4;
            switch ( input.LA(1) ) {
            case 27:
                {
                alt4=1;
                }
                break;
            case 26:
                {
                alt4=2;
                }
                break;
            case 28:
                {
                alt4=3;
                }
                break;
            case 30:
            case 31:
            case 32:
            case 33:
            case 34:
            case 35:
                {
                alt4=4;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 4, 0, input);

                throw nvae;
            }

            switch (alt4) {
                case 1 :
                    // MeterSimulatorScanner.g:64:4: ^( '&&' a= condition b= condition )
                    {
                    match(input,27,FOLLOW_27_in_condition305); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_condition_in_condition309);
                    condition();

                    state._fsp--;

                    pushFollow(FOLLOW_condition_in_condition313);
                    condition();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 2 :
                    // MeterSimulatorScanner.g:65:4: ^( '||' a= condition b= condition )
                    {
                    match(input,26,FOLLOW_26_in_condition320); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_condition_in_condition324);
                    condition();

                    state._fsp--;

                    pushFollow(FOLLOW_condition_in_condition328);
                    condition();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 3 :
                    // MeterSimulatorScanner.g:66:4: ^( '!' a= condition )
                    {
                    match(input,28,FOLLOW_28_in_condition335); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_condition_in_condition339);
                    condition();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 4 :
                    // MeterSimulatorScanner.g:67:4: (a= comparecondition )
                    {
                    // MeterSimulatorScanner.g:67:4: (a= comparecondition )
                    // MeterSimulatorScanner.g:67:5: a= comparecondition
                    {
                    pushFollow(FOLLOW_comparecondition_in_condition348);
                    comparecondition();

                    state._fsp--;


                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "condition"


    // $ANTLR start "comparecondition"
    // MeterSimulatorScanner.g:70:1: comparecondition : ( ^( '<' a= fourexpr b= fourexpr ) | ^( '<=' a= fourexpr b= fourexpr ) | ^( '>' a= fourexpr b= fourexpr ) | ^( '>=' a= fourexpr b= fourexpr ) | ^( '==' a= fourexpr b= fourexpr ) | ^( '!=' a= fourexpr b= fourexpr ) );
    public final void comparecondition() throws RecognitionException {
        try {
            // MeterSimulatorScanner.g:71:2: ( ^( '<' a= fourexpr b= fourexpr ) | ^( '<=' a= fourexpr b= fourexpr ) | ^( '>' a= fourexpr b= fourexpr ) | ^( '>=' a= fourexpr b= fourexpr ) | ^( '==' a= fourexpr b= fourexpr ) | ^( '!=' a= fourexpr b= fourexpr ) )
            int alt5=6;
            switch ( input.LA(1) ) {
            case 30:
                {
                alt5=1;
                }
                break;
            case 31:
                {
                alt5=2;
                }
                break;
            case 32:
                {
                alt5=3;
                }
                break;
            case 33:
                {
                alt5=4;
                }
                break;
            case 34:
                {
                alt5=5;
                }
                break;
            case 35:
                {
                alt5=6;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 5, 0, input);

                throw nvae;
            }

            switch (alt5) {
                case 1 :
                    // MeterSimulatorScanner.g:71:4: ^( '<' a= fourexpr b= fourexpr )
                    {
                    match(input,30,FOLLOW_30_in_comparecondition361); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_comparecondition365);
                    fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_comparecondition369);
                    fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 2 :
                    // MeterSimulatorScanner.g:72:4: ^( '<=' a= fourexpr b= fourexpr )
                    {
                    match(input,31,FOLLOW_31_in_comparecondition376); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_comparecondition380);
                    fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_comparecondition384);
                    fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 3 :
                    // MeterSimulatorScanner.g:73:4: ^( '>' a= fourexpr b= fourexpr )
                    {
                    match(input,32,FOLLOW_32_in_comparecondition391); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_comparecondition395);
                    fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_comparecondition399);
                    fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 4 :
                    // MeterSimulatorScanner.g:74:4: ^( '>=' a= fourexpr b= fourexpr )
                    {
                    match(input,33,FOLLOW_33_in_comparecondition406); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_comparecondition410);
                    fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_comparecondition414);
                    fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 5 :
                    // MeterSimulatorScanner.g:75:4: ^( '==' a= fourexpr b= fourexpr )
                    {
                    match(input,34,FOLLOW_34_in_comparecondition421); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_comparecondition425);
                    fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_comparecondition429);
                    fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 6 :
                    // MeterSimulatorScanner.g:76:4: ^( '!=' a= fourexpr b= fourexpr )
                    {
                    match(input,35,FOLLOW_35_in_comparecondition436); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_fourexpr_in_comparecondition440);
                    fourexpr();

                    state._fsp--;

                    pushFollow(FOLLOW_fourexpr_in_comparecondition444);
                    fourexpr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "comparecondition"

    // Delegated rules


 

    public static final BitSet FOLLOW_expr_in_prog60 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_fourexpr_in_expr76 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ifcondition_in_expr85 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_14_in_fourexpr98 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr102 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr106 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_15_in_fourexpr113 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr117 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr121 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_16_in_fourexpr128 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr132 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr136 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_17_in_fourexpr143 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr147 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr151 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_18_in_fourexpr158 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr162 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr166 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_CONSTANT_in_fourexpr172 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_fourexpr177 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_F0_in_fourexpr184 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_F1_in_fourexpr190 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr194 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_F1DATE_in_fourexpr201 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr205 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_F2_in_fourexpr212 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr216 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_fourexpr220 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DOUBLE_in_fourexpr226 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INTEGER_in_fourexpr231 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_21_in_ifcondition244 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_condition_in_ifcondition248 = new BitSet(new long[]{0x000000000027DFE0L});
    public static final BitSet FOLLOW_expr_in_ifcondition252 = new BitSet(new long[]{0x0000000003000000L});
    public static final BitSet FOLLOW_elseifcondition_in_ifcondition256 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_24_in_elseifcondition269 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_condition_in_elseifcondition273 = new BitSet(new long[]{0x000000000027DFE0L});
    public static final BitSet FOLLOW_expr_in_elseifcondition277 = new BitSet(new long[]{0x0000000003000000L});
    public static final BitSet FOLLOW_elseifcondition_in_elseifcondition281 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_25_in_elseifcondition288 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_elseifcondition292 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_27_in_condition305 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_condition_in_condition309 = new BitSet(new long[]{0x0000000FDC000000L});
    public static final BitSet FOLLOW_condition_in_condition313 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_26_in_condition320 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_condition_in_condition324 = new BitSet(new long[]{0x0000000FDC000000L});
    public static final BitSet FOLLOW_condition_in_condition328 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_28_in_condition335 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_condition_in_condition339 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_comparecondition_in_condition348 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_30_in_comparecondition361 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition365 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition369 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_31_in_comparecondition376 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition380 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition384 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_32_in_comparecondition391 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition395 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition399 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_33_in_comparecondition406 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition410 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition414 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_34_in_comparecondition421 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition425 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition429 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_35_in_comparecondition436 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition440 = new BitSet(new long[]{0x000000000007DFE0L});
    public static final BitSet FOLLOW_fourexpr_in_comparecondition444 = new BitSet(new long[]{0x0000000000000008L});

}